org.apache.ignite.ml.dataset.impl.bootstrapping

## Class BootstrappedDatasetBuilder<K,V>

- java.lang.Object
- - org.apache.ignite.ml.dataset.impl.bootstrapping.BootstrappedDatasetBuilder<K,V>

- Type Parameters:
    `K` - Type of a key in `upstream` data.
    `V` - Type of a value in `upstream` data.
  All Implemented Interfaces:
    Serializable, PartitionDataBuilder<K,V,EmptyContext,BootstrappedDatasetPartition>

      public class BootstrappedDatasetBuilder<K,V>
      extends Object
      implements PartitionDataBuilder<K,V,EmptyContext,BootstrappedDatasetPartition>

  Builder for bootstrapped dataset. Bootstrapped dataset consist of several subsamples created in according to random sampling with replacements selection of vectors from original dataset. This realization uses `BootstrappedVector` containing each vector from original sample with counters of repetitions for each subsample. As heuristic this implementation uses Poisson Distribution for generating counter values.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BootstrappedDatasetBuilder(Preprocessor<K,V> preprocessor, int samplesCnt, double subsampleSize)` Creates an instance of BootstrappedDatasetBuilder.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `BootstrappedDatasetPartition` | `build(LearningEnvironment env, Iterator<UpstreamEntry<K,V>> upstreamData, long upstreamDataSize, EmptyContext ctx)` Builds a new partition `data` from a partition `upstream` data and partition `context`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.ignite.ml.dataset.PartitionDataBuilder

      `andThen, build`

- - ### Constructor Detail

    - #### BootstrappedDatasetBuilder

          public BootstrappedDatasetBuilder(Preprocessor<K,V> preprocessor,
                                            int samplesCnt,
                                            double subsampleSize)

      Creates an instance of BootstrappedDatasetBuilder.
      Parameters:
        `preprocessor` - Mapper of upstream entries into `LabeledVector`.
        `samplesCnt` - Samples count.
        `subsampleSize` - Subsample size.

  - ### Method Detail

    - #### build

          public BootstrappedDatasetPartition build(LearningEnvironment env,
                                                    Iterator<UpstreamEntry<K,V>> upstreamData,
                                                    long upstreamDataSize,
                                                    EmptyContext ctx)

      Builds a new partition `data` from a partition `upstream` data and partition `context`. Important: there is no guarantee that there will be no more than one UpstreamEntry with given key, UpstreamEntry should be thought rather as a container saving all data from upstream, but omitting uniqueness constraint. This constraint is omitted to allow upstream data transformers in `DatasetBuilder` replicating entries. For example it can be useful for bootstrapping.
      Specified by:
        `build` in interface `PartitionDataBuilder<K,V,EmptyContext,BootstrappedDatasetPartition>`
      Parameters:
        `env` - Learning environment.
        `upstreamData` - Partition `upstream` data.
        `upstreamDataSize` - Partition `upstream` data size.
        `ctx` - Partition `context`.
      Returns:
        Partition `data`.

${current.year} Copyright © Apache Software Foundation
| Follow @ApacheIgnite
Ignite Database and Caching Platform | : ver. 2.15.0
Release Date | : April 25 2023